//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}


int main()
{
  list<int> coll;

  INSERT_ELEMENTS(coll,2,6);
  INSERT_ELEMENTS(coll,4,9);
  PRINT_ELEMENTS(coll," :\n");

  //  ,    ,  5,
  //   55
  cout << ToRus("   5  55:\n");
  replace_copy(coll.begin(), coll.end(),           // 
               ostream_iterator<int>(cout," "),    // 
               5,                                  //  
               55);                                //  
  cout << endl;

  //  ,    ,  5,
  //   42
  cout << ToRus("   ,  5,  42:\n");
  replace_copy_if(coll.begin(), coll.end(),        // 
                  ostream_iterator<int>(cout," "), // 
                  bind2nd(less<int>(),5),     //  
                  42);                        //  
  cout << endl;

  //  ,       
  cout << ToRus("      :\n");
  replace_copy_if(coll.begin(), coll.end(),        // 
                  ostream_iterator<int>(cout," "), // 
                  bind2nd(modulus<int>(),2),  //  
                  0);                         //  
  cout << endl;


  getch();
  return 0;
}

//---------------------------------------------------------------------------